// 展开所有折叠, 默认fasle, 折叠
unbox_all = false;
// 显示音节划分, 默认true,显示,点击会自动切换
show_syllable = true;
// 隐藏翻译, 默认true 显示
show_translation = true;
// 简化词性, 默认false
simplify_pos = false;
// 简化语法, 默认false
simplify_grammar = false;
// 显示多词义导航(仅有多词义显示)
show_nav = true;
// 在线发音 (默认离线) 启用后,可以删除 1.mdd
online_pron = false;
// 在线图片 (默认离线) 启用后,可以删除 2.mdd
online_image = false;

// 英语释义支持点击折叠,默认开启
enable_collapse = true;
// Idioms / phrasal verb支持折叠展开
hideIdioms = true;
hidePhrasalVerb = true;

// 释义例句简化 something/somebody 缩写
sb_sth_abbr = false;
// 加入中文 和 例句显示按钮
oald_control = true;


// 例句,释义,在线tts发音,需要高版本浏览器内核. Mdict不支持
enable_online_tts = false;
// 英音发音配置  英音男1 - 英音男2  ; 英音女1 - 英音女3
gb_tts = "英音男1";
// 美音发音配置  美音男1 - 美音男5 ;  美音女1 - 美音女4
us_tts = "美音女1";
is_oald_loaded = 'undefined' != typeof (is_oald_loaded)
console.log("~~~~~~~is_oald_loaded ", is_oald_loaded)

oald_root_class = "leon-oald"
oald_root_selector = "." + oald_root_class
oald_nav_class = "nav-oald"
oald_nav_selector = "." + oald_nav_class
oald_control_class = "control"
oald_control_selector = "." + oald_control_class

var globalAudio = new Audio();
var prefix_uk = "https://www.oxfordlearnersdictionaries.com/media/english/uk_pron/";
var prefix_us = "https://www.oxfordlearnersdictionaries.com/media/english/us_pron/";
var prefix_full_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/fullsize/";
var prefix_thumb_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/thumb/";

// 挂载全局对象,进行方法隔离
leon_oald = {
    root: function () {
        let oald = document.querySelector(oald_root_selector);
        if (!oald) return document;
        return oald.parentElement ? oald.parentElement : oald;
    },
    toggle_enlarger: function (ctl) {
        var fullsize = ctl.children[0].children[0],
            thumb = ctl.children[0].children[1];
        if (!fullsize.style.display || fullsize.style.display === 'none') {
            thumb.style.display = 'none';
            fullsize.style.display = 'block';
        } else {
            fullsize.style.display = 'none';
            thumb.style.display = 'block';
        }
    },
    toggle_active: function (ctl) {
        ctl.parentElement.classList.toggle('is-active');
    },
    toggle_syllable: function (ctl) {
        if (ctl.hasAttribute("syllable")) {
            ctl.textContent = ctl.textContent.indexOf("·") > -1 ? ctl.textContent.replace(/·/g, "") : ctl.getAttribute("syllable");
        }
    },
    get_online_pron_url: function (src) {
        var parts = src.split('/');
        var name = parts[parts.length - 1];
        return (name.indexOf("_gb_") > -1 ? prefix_uk : prefix_us) + name.substring(0, 1) + '/' + name.substring(0, 3) + '/' + name.substring(0, 5) + '/' + name;
    },
    get_online_image_url: function (src) {
        var parts = src.split('/');
        parts = parts[parts.length - 1].split('_');
        var name = parts[1];
        console.log(parts)
        return (parts[0] === "fullsize" ? prefix_full_image : prefix_thumb_image) + name.substring(0, 1) + '/' + name.substring(0, 3) + '/' + name.substring(0, 5) + '/' + name;
    },
    addNavigation: function () {
        let root = leon_oald.root();
        // 已添加不添加
        console.log("__", root, root.querySelector(oald_nav_selector))
        if (root.querySelector(oald_nav_selector))
            return;

        let eles = root.querySelectorAll(".oald");
        console.log("addNavigation", eles.length);
        // 只有一个entry不添加
        if (eles.length < 2)
            return;
        let container = document.createElement('div');
        container.setAttribute("class", oald_nav_class);
        for (let i = 0; i < eles.length; i++) {
            let sp = document.createElement('span');
            let pos = eles[i].querySelector(".pos");
            pos = pos && pos.textContent;
            pos = !pos ? eles[i].querySelector(".headword").textContent : pos;
            sp.textContent = POS[pos] ? POS[pos] : pos;
            if (i === 0) {
                sp.classList.add('active');
            }
            sp.addEventListener("click", function () {
                let index = leon_oald.navIndex(this);
                console.log(index);
                for (let j = 0; j < container.children.length; j++) {
                    container.children[j].classList.remove('active');
                }
                this.classList.add('active');
                leon_oald.showHideEntry(index)
            })
            container.appendChild(sp);
        }

        // 新增ALL
        let sp = document.createElement('span');
        sp.textContent = "All";
        container.appendChild(sp)
        sp.addEventListener("click", function () {
            for (let j = 0; j < container.children.length; j++) {
                container.children[j].classList.remove('active');
            }
            this.classList.add('active');
            leon_oald.showHideEntry(-1)
        })
        leon_oald.showHideEntry(0);
        sp.click();	// 默认显示所有词性(ALL)，删除则从第一个词性开始
        root.insertBefore(container, root.childNodes[0]);
    },
    addControl: function () {
        let root = leon_oald.root();
        // 已添加不添加
        console.log("__", root, root.querySelector(oald_control_selector))
        if (root.querySelector(oald_control_selector))
            return;

        elementsFn(oald_root_selector + " .headword ~.pos", function (ele) {
            let container = document.createElement('span');
            container.setAttribute("class", oald_control_class);
            let chn = document.createElement('span');
            chn.textContent = "中文"
            chn.classList.add("chn-control")
            if (!show_translation) {
                chn.classList.add('collapse');
            }
            let examples = document.createElement('span');
            examples.textContent = "例句"
            examples.classList.add("examples-control")
            chn.addEventListener("click", function () {
                elementsFn(oald_root_selector + " .chn-control", function (ele) {
                    ele.classList.toggle('collapse');
                })
                elementsDisplay(oald_root_selector + " chn", this.classList.contains('collapse') ? "none" : "inline")
            })
            examples.addEventListener("click", function () {
                elementsFn(oald_root_selector + " .examples-control", function (ele) {
                    ele.classList.toggle('collapse');
                })
                elementsDisplay(oald_root_selector + " .examples", this.classList.contains('collapse') ? "block" : "none")
            })
            container.appendChild(chn);
            container.appendChild(examples);
            if (ele.classList.contains("idm")) {
                ele.appendChild(container)
            } else {
                ele.insertAdjacentElement("afterend", container)
            }
        })

    },
    navIndex: function (ele) {
        var eles = document.querySelectorAll(oald_nav_selector + " span");
        for (var i = 0; i < eles.length; i++) {
            if (eles[i] === ele)
                return i;
        }
    },
    showHideEntry: function (index) {
        var root = leon_oald.root();
        var eles = root.querySelectorAll(".oald");
        for (var i = 0; i < eles.length; i++) {
            if (index === i || index < 0)
                showEle(eles[i]);
            else
                hideEle(eles[i]);
        }
    },
    fixLink: function () {
        elementsFn("a.Ref", function (ele) {
            if (ele.title ==="Idioms definitio" || ele.title ==="Phrasal Verbs definition") {
                var start = ele.href.indexOf("=") !== -1 ? (ele.href.indexOf("=") + 1) : (ele.href.indexOf("#") !== -1 ? ele.href.indexOf("#") + 1 : 0)
                ele.href = (start === 0 ? "":"#" )+ ele.href.substring(start)
            }
        })
    },
    addOnlineTts: function () {
        // 在线tts
        elementsFn(oald_root_selector + " .x,.unx", function (element) {
            //  console.log("______", element)
            let pron_uk = document.createElement('span');
            pron_uk.setAttribute("class", "sound audio_play_button pron-uk icon-audio");
            pron_uk.onclick = function () {
                selectedTts = gb_tts;
                speak(element.firstChild.nodeValue);
            }
            let pron_us = document.createElement('span');
            pron_us.setAttribute("class", "sound audio_play_button pron-us icon-audio");
            pron_us.onclick = function () {
                selectedTts = us_tts;
                speak(element.firstChild.nodeValue);
            }
            element.parentNode.insertBefore(pron_uk, element);
            element.parentNode.insertBefore(pron_us, element);
        });
    }
}


!is_oald_loaded && document.addEventListener('DOMContentLoaded', function () {
    elementsFn(oald_root_selector + " #ox-enlarge", function (element) {
        element.addEventListener("click", function () {
            leon_oald.toggle_enlarger(element);
        })
    });
    elementsFn(oald_root_selector + " .box_title", function (element) {
        element.addEventListener("click", function () {
            leon_oald.toggle_active(element);
        })
        if (unbox_all)
            leon_oald.toggle_active(element)
    });
    elementsFn(oald_root_selector + " .headword", function (element) {
        element.addEventListener("click", function () {
            leon_oald.toggle_syllable(element);
        })
        if (!show_syllable)
            leon_oald.toggle_syllable(element)
    });
    elementsFn(oald_root_selector + " chn", function (element) {
        if (!show_translation)
            element.style.display = 'none';
    });

    simplify_pos && elementsFn(oald_root_selector + "  .pos", function (element) {
        element.textContent = POS[element.textContent];
    });
    simplify_grammar && elementsFn(oald_root_selector + "  .grammar", function (element) {
        element.textContent = GRAMMAR[element.textContent];
    });
    sb_sth_abbr && elementsFn(oald_root_selector + " .x,.def", function (element) {
        element.innerHTML = element.innerHTML
            .replace(/\bsomething\b/g, "sth")
            .replace(/\bsomebody\b/g, "sb")
        ;
    });
    show_nav && leon_oald.addNavigation();

    online_pron && elementsFn(oald_root_selector + "  .audio_play_button", function (element) {
        console.log(element);
        element.href = leon_oald.get_online_pron_url(element.href);
        //console.log(get_online_pron_url(element.href));
        element.onclick = function (e) {
            e.preventDefault();
            globalAudio.src = element.href;
            globalAudio.play();
            // new Audio(element.href).play();
        }
    });

    online_image && elementsFn(oald_root_selector + " .fullsize, .thumb", function (element) {
        console.log(element);
        element.src = leon_oald.get_online_image_url(element.src);
        console.log(element);
    });

    hideIdioms && elementsHide(oald_root_selector + " .idioms>span:not(:first-child)");
    hidePhrasalVerb && elementsHide(oald_root_selector + " .phrasal_verb_links>.pvrefs");

    elementsClick(oald_root_selector + " .idioms>span:first-child,.phrasal_verb_links>span:first-child,.shcut", function (ele) {
        if (!ele.nextElementSibling)
            return;
        var state = ele.nextElementSibling.style.display;
        console.log("state tg", state, !state)
        if (state === "none") {
            nodeDisplay(ele, "block")
        } else {
            nodeDisplay(ele, "none")
        }
    });

    enable_collapse && elementsClick(oald_root_selector + "  .sense>span:first-child", function (ele) {
        if (!ele.nextElementSibling)
            return;
        var state = ele.nextElementSibling.style.display;
        if (state === "block") {
            nodeDisplay(ele, "none", false, false, function (ele) {
                return ele.className !== "examples"
            })
        } else {
            nodeDisplay(ele, "block", false, false, function (ele) {
                return ele.className !== "examples"
            })
        }
    });
    var excludeTagName = ["DEFT", "CHN"]
    // 释义 def
    enable_collapse && elementsClick(oald_root_selector + "  .def", function (ele) {
        if (!ele.nextElementSibling)
            return;

        let next = ele.nextElementSibling;
        while (next && excludeTagName.indexOf(next.tagName) > -1) {
            next = next.nextElementSibling
        }
        var state = next && next.style && next.style.display;

        if (state === "block") {
            nodeDisplay(ele, "none", true, false, function (ele) {
                return excludeTagName.indexOf(ele.tagName) > -1
            })
        } else {
            nodeDisplay(ele, "block", true, false, function (ele) {
                return excludeTagName.indexOf(ele.tagName) > -1
            })
        }
    })

    oald_control && leon_oald.addControl()
    leon_oald.fixLink()
});


/* 精简 */
/*词性*/
var POS = {
    "noun": "n.",
    "adjective": "adj.",
    "adverb": "adv.",
    "abbreviation": "abbr.",
    "adverb, adjective": "adv., adj.",
    "verb": "v.",
    "phrasal verb": "phrasal v.",
    "exclamation": "interj.",
    "idiom": "idiom",
    "conjunction": "conj.",
    "preposition": "prep.",
    "modal verb": "modal v.",
    "combining form": "combining form",
    "prefix": "prefix",
    "linking verb": "linking v.",
    "suffix": "suffix",
    "number": "num.",
    "pronoun": "pron.",
    "ordinal number": "ordinal num.",
    "determiner": "det.",
    "auxiliary verb": "aux. v.",
    "indefinite article": "indefinite a.",
    "definite article": "definite a.",
    "infinitive marker": "infinitive marker",
    "symbol": "symbol",
    "adjective, adverb": "adj., adv.",
    "adverb, preposition": "adv., prep.",
    "noun, adjective": "n., adj.",
    "short form": "short form",
    "noun, exclamation": "n., interj.",
    "exclamation, noun": "interj., n.",
    "determiner, pronoun": "det., pron.",
    "preposition, adverb": "prep., adv.",
    "adjective, exclamation": "adj., interj.",
    "preposition, conjunction, adverb": "prep., conj., adv.",
    "adjective, adverb, exclamation": "adj., adv., interj.",
    "adjective, noun": "adj., n.",
    "adverb, exclamation": "adv., interj.",
    "noun, determiner": "n., det.",
    "determiner, pronoun, adverb": "det., pron., adv.",
    "conjunction, preposition": "conj., prep.",
    "adverb, pronoun, conjunction": "adv., pron., conj.",
    "determiner, adjective": "det., adj.",
    "determiner, ordinal number": "det., ordinal num.",
    "noun, abbreviation": "n., abbr.",
    "exclamation, adjective": "interj., adj.",
    "conjunction, adverb": "conj., adv.",
    "adjective, pronoun": "adj., pron.",
    "number, determiner": "num., det.",
    "noun, verb": "n., v.",
    "pronoun, determiner": "pron., det.",
    "preposition, conjunction": "prep., conj.",
    "exclamation, adverb, pronoun": "interj., adv., pron.",
    "adverb, conjunction": "adv., conj.",
    "adverb, noun": "adv., n.",
}

/*语法*/
var GRAMMAR = {
    "[uncountable]": "[U]",
    "[only before noun]": "[only bf N]",
    "[singular]": "[sing]",
    "[countable]": "[C]",
    "[countable, uncountable]": "[C, U]",
    "[after noun]": "[aft N]",
    "[not before noun]": "[not bf N]",
    "[usually before noun]": "[usu bf N]",
    "[usually singular]": "[usu sing]",
    "[uncountable, countable]": "[U, C]",
    "[intransitive, transitive]": "[I, T]",
    "[usually passive]": "[usu psv]",
    "[plural]": "[pl]",
    "[transitive]": "[T]",
    "[uncountable, singular]": "[U, sing]",
    "[intransitive]": "[I]",
    "[often passive]": "[oft psv]",
    "[not usually before noun]": "[not usu bf N]",
    "[singular, uncountable]": "[sing, U]",
    "[uncountable, plural]": "[U, pl]",
    "[usually plural]": "[usu pl]",
    "[countable, usually plural]": "[C, usu pl]",
    "[uncountable, countable, usually singular]": "[U, C, usu sing]",
    "[transitive, intransitive]": "[T, I]",
    "[intransitive, transitive, often passive]": "[I, T, oft psv]",
    "[transitive, often passive]": "[T, oft psv]",
    "[countable, usually singular]": "[C, usu sing]",
    "[countable + singular or plural verb]": "[C + sing or pl V]",
    "[uncountable + singular or plural verb]": "[U + sing or pl V]",
    "[transitive, usually passive]": "[T, usu psv]",
    "[transitive, often passive, intransitive]": "[T, oft psv, I]",
    "[no passive]": "[no psv]",
    "[countable, usually singular, uncountable]": "[C, usu sing, U]",
    "[countable, usually plural, uncountable]": "[C, usu pl, U]",
    "[plural, singular or plural verb]": "[pl, sing or pl V]",
    "[singular + singular or plural verb]": "[sing + sing or pl V]",
    "[countable, singular, uncountable]": "[C, sing, U]",
    "[intransitive, transitive, no passive]": "[I, T, no psv]",
    "[transitive, no passive]": "[T, no psv]",
    "[uncountable, countable, usually plural]": "[U, C, usu pl]",
    "[plural, uncountable]": "[pl, U]",
    "[countable + singular or plural verb, uncountable]": "[C + sing or pl V, U]",
    "[transitive, intransitive, often passive]": "[T, I, oft psv]",
    "[intransitive, transitive, usually passive]": "[I, T, usu psv]",
    "[transitive, usually passive, intransitive]": "[T, usu psv, I]",
    "[countable, plural]": "[C, pl]",
    "[singular or plural verb]": "[sing or pl V]",
    "[countable, uncountable + singular or plural verb]": "[C, U + sing or pl V]",
    "[uncountable + singular or plural verb, countable]": "[U + sing or pl V, C]",
    "[countable, singular]": "[C, sing]",
    "[uncountable, countable, singular]": "[U, C, sing]",
    "[countable, singular + singular or plural verb]": "[C, sing + sing or pl V]",
    "[singular + singular or plural verb, uncountable]": "[sing + sing or pl V, U]",
    "[transitive, no passive, intransitive]": "[T, no psv, I]",
    "[usually singular, uncountable]": "[usu sing, U]",
    "[transitive, intransitive, usually passive]": "[T, I, usu psv]",
}


// 通用方法

function hideEle(ele) {
    ele.style.display = 'none';
}

function showEle(ele) {
    ele.style.display = 'block';
}

function elementsFn(selector, fn) {
    var eles = document.querySelectorAll(selector);
    for (var i = 0; i < eles.length; i++) {
        fn(eles[i]);
    }
}

function elementsClick(selector, fn) {
    elementsFn(selector, function (ele) {
        ele.addEventListener("click", function (event) {
            fn(ele, event);
        })
    })
}

function elementsDisplay(selector, value) {
    elementsFn(selector, function (ele) {
        ele.style.display = value;
    })
}

function nodeDisplay(node, value, fromThis, includeThis, excludeFunc, inlineList) {
    var nodes = node.parentElement.childNodes;
    var isFindThis = false
    for (var i = 0; i < nodes.length; i++) {
        let currentNode = nodes[i];
        if (excludeFunc && excludeFunc(currentNode)) {
            continue;
        }
        if (fromThis) {
            if (node === currentNode) {
                isFindThis = true;
            }
            if (!isFindThis)
                continue;
        }
        if (!includeThis && node === currentNode)
            continue;

        if (currentNode.style) {
            var display = "block"
            if (inlineList && inlineList.indexOf(currentNode.className) > -1) {
                display = "inline"
            }
            currentNode.style.display = value === "block" ? display : value;
        }
    }
}

function elementsHide(selector) {
    elementsDisplay(selector, "none")
}
